> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/web/get-started/samples/webviewer-react.md).

# Integrate WebViewer into React

Sample project to implement WebViewer into a React project

This sample is designed to show you how to integrate WebViewer into a React project. Read more about [integrating with React.](/web/get-started/libraries-and-frameworks/react.md)

You can watch [a video here](https://youtu.be/bVhWXuLSL0k) to help you get started.

WebViewer provides a slick out-of-the-box responsive UI that enables you to view, annotate and manipulate PDFs and other document types inside any web project.

Once you generate your license key, it will automatically be included in your sample code below.

{% @apryse-license-key/apryse-license-key platform="WEB\_VIEWER" variant="compact" %}

Click the button below to view the full project in GitHub.

{% tabs %}
{% tab title="TSX" %}
{% code title="App.tsx" lineNumbers="true" %}

```tsx
import { useRef, useEffect } from 'react';
import WebViewer, { type WebViewerInstance } from '@pdftron/webviewer';
import './App.css';

const App = () => {
  const viewer = useRef<HTMLDivElement | null>(null);

  useEffect(() => {
    const viewerElement = viewer.current;
    if (!viewerElement) return;

    let isUnmounted = false;
    let webViewerInstance: WebViewerInstance | null = null;
    let onDocumentLoaded: (() => void) | null = null;

    WebViewer(
      {
        path: '/lib/webviewer',
        initialDoc: 'https://apryse.s3.amazonaws.com/public/files/samples/WebviewerDemoDoc.pdf',
        licenseKey: import.meta.env.VITE_DEMO_KEY,  // sign up to get a free trial key at https://dev.apryse.com
      },
      viewerElement,
    ).then((instance: WebViewerInstance) => {
      if (isUnmounted) {
        instance.UI.dispose();
        return;
      }

      webViewerInstance = instance;

      // Access WebViewer instance here
      const { documentViewer, annotationManager, Annotations } = instance.Core;

      // Example: Add a rectangle annotation to the first page when the document is loaded
      onDocumentLoaded = () => {
        const rectangleAnnot = new Annotations.RectangleAnnotation({
          PageNumber: 1,
          // values are in page coordinates with (0, 0) in the top left
          X: 100,
          Y: 150,
          Width: 200,
          Height: 50,
          Author: annotationManager.getCurrentUser()
        });

        annotationManager.addAnnotation(rectangleAnnot);
        // Need to draw the annotation otherwise it won't show up until the page is refreshed
        annotationManager.redrawAnnotation(rectangleAnnot);
      };

      documentViewer.addEventListener('documentLoaded', onDocumentLoaded);
    });

    return () => {
      isUnmounted = true;

      if (webViewerInstance) {
        if (onDocumentLoaded) {
          webViewerInstance.Core.documentViewer.removeEventListener('documentLoaded', onDocumentLoaded);
        }

        webViewerInstance.UI.dispose();
      }
    };
  }, []);

  return (
    <div className="App">
      <div className="header">React sample</div>
      <div className="webviewer" ref={viewer}></div>
    </div>
  );
};

export default App;

```

{% endcode %}
{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/web/get-started/samples/webviewer-react.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
